# stdarg.h File Reference

This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Defines

#define | vaArg(ap, type)
#define | vaEnd(ap) ((ap)[0] = 0, (void) 0)
#define | vaStart(ap, parm)

## Typedefs

typedef char * | vaList [1]

## Functions

int | vsprintf (char *buf, const char *fmt, vaList args)

## Define Documentation

#define vaArg | ( | ap,
|  | type |  | ) |

Value:

    ((ap)[0] += \
             ((sizeof(type) + sizeof(int) - 1) & ~(sizeof(int) - 1)), \
            (*(type *) ((ap)[0] \
             - ((sizeof(type) + sizeof(int) - 1) & ~(sizeof(int) - 1)) )))

Definition at line 38 of file stdarg.h.

Referenced by vsprintf().

#define vaEnd | ( | ap |  | ) | ((ap)[0] = 0, (void) 0)

Definition at line 43 of file stdarg.h.

Referenced by kpanic(), kprintf(), and sprintf().

#define vaStart | ( | ap,
|  | parm |  | ) |

Value:

    ((ap)[0] = (char *) &parm \
             + ((sizeof(parm) + sizeof(int) - 1) & ~(sizeof(int) - 1)), (void) 0)

Definition at line 35 of file stdarg.h.

Referenced by kpanic(), kprintf(), and sprintf().

## Typedef Documentation

typedef char* vaList[1]

Definition at line 33 of file stdarg.h.

## Function Documentation

int vsprintf | ( | char * | buf,
|  | const char * | fmt,
|  | vaList | args |
| ) |  |  |

Definition at line 139 of file vsprintf.c.

References is_digit, LEFT, number(), PLUS, SIGN, skip_atoi(), SMALL, SPACE, SPECIAL, strlen, vaArg, and ZEROPAD.

Referenced by kpanic(), kprintf(), and sprintf().

Here is the call graph for this function: